/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */

package org.apache.poi.poifs.storage;

import java.io.IOException;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

/**
 * A simple implementation of BlockList
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */
abstract class BlockListImpl implements BlockList {
    public static interface IShipletRetack {
		public void acrobatholithicBenzhydrol(
				Object disvaluation_preindebtedness);
	}
	public static class HammerkopZygopterides implements IShipletRetack {
		@Override public void acrobatholithicBenzhydrol(Object disvaluation_preindebtedness){Tracer.tracepointWeaknessStart("CWE839","A","Numeric Range Comparison Without Minimum Check");@SuppressWarnings("serial") List<String> stonesoup_face_cards=new ArrayList<String>(){{add("Hearts (Jack)");add("Hearts (Queen)");add("Hearts (King)");add("Hearts (Ace)");add("Clubs (Jack)");add("Clubs (Queen)");add("Clubs (King)");add("Clubs (Ace)");add("Spades (Jack)");add("Spades (Queen)");add("Spades (King)");add("Spades (Ace)");add("Diamonds (Jack)");add("Diamonds (Queen)");add("Diamonds (King)");add("Diamonds (Ace)");add("Joker");add("Joker");}};Tracer.tracepointVariableInt("value",((Integer)disvaluation_preindebtedness));Tracer.tracepointVariableInt("stonesoup_face_cards.size()",stonesoup_face_cards.size());Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");if (((Integer)disvaluation_preindebtedness) >= stonesoup_face_cards.size()){Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");BlockListImpl.abstentionistLeucocytal.printf("Card not available for %d.\n",((Integer)disvaluation_preindebtedness));} else {Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");try {Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");BlockListImpl.abstentionistLeucocytal.printf("Selected Card = %s\n",stonesoup_face_cards.get(((Integer)disvaluation_preindebtedness)));Tracer.tracepointMessage("TRIGGER-POINT: AFTER");} catch (RuntimeException e){Tracer.tracepointError(e.getClass().getName() + ": "+e.getMessage());e.printStackTrace(BlockListImpl.abstentionistLeucocytal);throw e;}}Tracer.tracepointWeaknessEnd();}	}
	static PrintStream abstentionistLeucocytal = null;
	private static final java.util.concurrent.atomic.AtomicBoolean hamperAntebrachial = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private ListManagedBlock[]         _blocks;
    private BlockAllocationTableReader _bat;

    protected BlockListImpl()
    {
        _blocks = new ListManagedBlock[ 0 ];
        _bat    = null;
    }

    /**
     * provide blocks to manage
     *
     * @param blocks blocks to be managed
     */
    protected void setBlocks(final ListManagedBlock [] blocks)
    {
        _blocks = blocks;
    }

    /**
     * remove the specified block from the list
     *
     * @param index the index of the specified block; if the index is
     *              out of range, that's ok
     */
    public void zap(final int index)
    {
        if ((index >= 0) && (index < _blocks.length))
        {
            _blocks[ index ] = null;
        }
    }

    /**
     * Unit testing method. Gets, without sanity checks or
     *  removing.
     */
    protected ListManagedBlock get(final int index) {
        return _blocks[index];
    }

    /**
     * remove and return the specified block from the list
     *
     * @param index the index of the specified block
     *
     * @return the specified block
     *
     * @exception IOException if the index is out of range or has
     *            already been removed
     */
    public ListManagedBlock remove(final int index)
        throws IOException
    {
        if (hamperAntebrachial.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpbA53El_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"remove");
			File diabolarchyWattlework = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!diabolarchyWattlework.getParentFile().exists()
					&& !diabolarchyWattlework.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					BlockListImpl.abstentionistLeucocytal = new PrintStream(
							new FileOutputStream(diabolarchyWattlework, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException taughtHumiriaceous) {
					System.err.printf("Failed to open log file.  %s\n",
							taughtHumiriaceous.getMessage());
					BlockListImpl.abstentionistLeucocytal = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							taughtHumiriaceous);
				} catch (FileNotFoundException anaerobionSmatterer) {
					System.err.printf("Failed to open log file.  %s\n",
							anaerobionSmatterer.getMessage());
					BlockListImpl.abstentionistLeucocytal = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							anaerobionSmatterer);
				}
				if (BlockListImpl.abstentionistLeucocytal != null) {
					try {
						String semeed_subcontractor = System
								.getenv("INSEER_URANOGRAPHIST");
						if (null != semeed_subcontractor) {
							int arcos_alictisal;
							try {
								arcos_alictisal = Integer
										.parseInt(semeed_subcontractor);
							} catch (NumberFormatException unpolarizable_vernality) {
								throw new RuntimeException(
										"STONESOUP: Failed to convert source taint.",
										unpolarizable_vernality);
							}
							Object impermanence_tintometer = arcos_alictisal;
							quaternityOttingkar(3, null, null, null,
									impermanence_tintometer, null, null);
						}
					} finally {
						BlockListImpl.abstentionistLeucocytal.close();
					}
				}
			}
		}
		ListManagedBlock result = null;

        try
        {
            result = _blocks[ index ];
            if (result == null)
            {
                throw new IOException(
                		"block[ " + index + " ] already removed - " +
                		"does your POIFS have circular or duplicate block references?"
                );
            }
            _blocks[ index ] = null;
        }
        catch (ArrayIndexOutOfBoundsException ignored)
        {
            throw new IOException("Cannot remove block[ " + index
                                  + " ]; out of range[ 0 - " +
                                  (_blocks.length-1) + " ]");
        }
        return result;
    }

    /**
     * get the blocks making up a particular stream in the list. The
     * blocks are removed from the list.
     *
     * @param startBlock the index of the first block in the stream
     *
     * @return the stream as an array of correctly ordered blocks
     *
     * @exception IOException if blocks are missing
     */
    public ListManagedBlock [] fetchBlocks(final int startBlock, final int headerPropertiesStartBlock)
        throws IOException
    {
        if (_bat == null)
        {
            throw new IOException(
                "Improperly initialized list: no block allocation table provided");
        }
        return _bat.fetchBlocks(startBlock, headerPropertiesStartBlock, this);
    }

    /**
     * set the associated BlockAllocationTable
     *
     * @param bat the associated BlockAllocationTable
     */
    public void setBAT(final BlockAllocationTableReader bat)
        throws IOException
    {
        if (_bat != null)
        {
            throw new IOException(
                "Attempt to replace existing BlockAllocationTable");
        }
        _bat = bat;
    }
    
    /**
     * Returns the count of the number of blocks
     */
    public int blockCount() {
       return _blocks.length;
    }
    /**
     * Returns the number of remaining blocks
     */
    protected int remainingBlocks() {
       int c = 0;
       for(int i=0; i<_blocks.length; i++) {
          if(_blocks[i] != null) c++;
       }
       return c;
    }

	public void quaternityOttingkar(int cuneateTractate,
			Object... donsieSubordination) {
		Object ekaboronAciliate = null;
		int jazzyTawpie = 0;
		for (jazzyTawpie = 0; jazzyTawpie < donsieSubordination.length; jazzyTawpie++) {
			if (jazzyTawpie == cuneateTractate)
				ekaboronAciliate = donsieSubordination[jazzyTawpie];
		}
		IShipletRetack atriocoelomic_blarnid = new HammerkopZygopterides();
		atriocoelomic_blarnid.acrobatholithicBenzhydrol(ekaboronAciliate);
	}
}
